<?php

$thumbs_dir  = "./images-thumbs/";
	
$fullsize_dir = "./images-fullsize/";

$gallery_title = 'Simple gallery by Bokeh';

$gallery_heading = 'Simple gallery';

##################################################################################
	
$content = null;

$page = (!empty($_GET['p'])) ? preg_replace('/[^0-9]/', '', $_GET['p']) : null ;

$results_per_page = 20;

/* The following block has been removed as it caused a major slow down 
once the images directory started filling up. The glob and filemtime 
functions seemed to be responsible.

if(($count = count($glob = glob($thumbs_dir."*.jpg"))) > 0)
{
    array_multisort(array_map('filemtime', $glob), SORT_DESC, $glob); 
*/

# START: This is the replacement code
$glob = array();
$filemtime = array();
if ($dh = opendir($thumbs_dir)) {
	while (($file = readdir($dh)) !== false) {
		if('.jpg' === substr($file, -4))
		{
			$glob[] = $thumbs_dir . $file;
			$filemtime[] = substr($file, 0, strlen($file)-4);
		}
	}
	closedir($dh);
}

if(($count = count($glob)) > 0)
{
    array_multisort($filemtime, SORT_DESC, $glob);
#END: This is the replacement code
    $total_pages = $count ? ceil($count / $results_per_page) : 1 ;
    if(!isset($_GET['i']))
    {
	    $page = ((is_numeric($page)) and ($page >= 1) and ($page <= $total_pages)) ? (int)$page : 1 ;
	    $files = array_slice($glob, (($results_per_page * $page) - $results_per_page), $results_per_page);
	    $content .= ($links = pagination_links($page, $count, $results_per_page)."\n");
	    $content .= '<ul id="gallery">'."\n";
	    foreach($files as $file)
	    {
	        $content .= '<li><a href="?i='.preg_replace('/\.jpg$/', '', substr($file, strlen($thumbs_dir))).'"><img src="'.$file.'" alt=""></a></li>'."\n";
	    }
	    $content .= '</ul>'."\n";
	    $content .= $links;
	}
	else
	{
		$image = preg_replace('/[^0-9]/', '', $_GET['i']);
		list($key,) = array_keys($glob, $thumbs_dir.$image.'.jpg');
		$left = isset($glob[$key - 1]) ? '<a href="?i='.preg_replace('/[^0-9]/', '', $glob[$key - 1]).'"><img src="./arrows/left-" alt=""></a>' : null ;
		$center = '<a href="?p='.($page = ceil(($key + 1)/$results_per_page)).'"><img src="./arrows/up-" alt=""></a>';
		$right = isset($glob[$key + 1]) ? '<a href="?i='.preg_replace('/[^0-9]/', '', $glob[$key + 1]).'"><img src="./arrows/right-" alt=""></a>' : null ;
		$content = '<p class="arrows">'.$left . $center . $right.'</p>'."\n".'<p><a href="?p='.$page.'"><img src="'.$fullsize_dir.$image.'" alt=""></a></p>'."\n".pagination_links($page, $count, $results_per_page)."\n";
	}
}



function pagination_links($page, $count, $results_per_page, $each_direction = 5)
{
    $word_for_previous = 'prev';
    $word_for_next = 'next';
	$total_pages = $count ? ceil($count / $results_per_page) : 1 ;
    if($total_pages < 2)
    {
	    return null;
    }
    $page = ((is_numeric($page)) and ($page >= 1) and ($page <= $total_pages)) ? (int)$page : 1 ;
    $output = null;
    if($page > 1)
    {
        $output .= '<a href="?p='.($page - 1).'">'.$word_for_previous.'</a>'."\n".' | '."\n";
    }
    for($i = $page - $each_direction; $i <= $page + $each_direction; $i++)
    {
        if(($i > 0) and ($i <= $total_pages))
        {
            $output .= isset($spacer) ? $spacer : null ;
            $spacer = ' | '."\n";
            if($page != $i)
            {
                $output .= '<a href="?p='.$i.'">'.$i.'</a>'."\n";
            }
            else
            {
                $output .= '<span class="bold">'.$i."</span>\n";
            }
        }
    }
    if($page < $total_pages)
    {
        $output .= ' | '."\n".'<a href="?p='.($page + 1).'">'.$word_for_next.'</a>'."\n";
    }
    return '<p class="pagination-links">'."\n".$output.'</p>';
}

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">
    
<style type="text/css">
html, body,{
	margin:0;
	padding:0;
}

h1{
    font-size:large;
    margin:0 auto;
    padding:1em 0 0 0;
    text-align:center;
    font-family:  verdana, sans-serif;
}
	
ul#gallery {
    margin:0 auto;
    padding:0;
    list-style-type:none;
    width:80%;
    font-family: Tahoma;
}

ul#gallery li {
    float: left;
    margin:10px 15px;
}

ul#gallery li img {
    border:0;
}

p{
    text-align:center;
    padding:0;
    margin:0;
}

p.pagination-links{
    clear:both;
    margin:0;
    padding:1em 0;
    text-align:center;
}

.arrows img{
    border: 0;
}

.bold{
    font-weight:bold;
}
</style>

<title><?php echo $gallery_title ?></title>
  
</head>

<body>
<h1><?php echo $gallery_heading ?></h1>

<?php echo $content ?>

<p><a href="admin/">Admin panel</a></p>

</body>
</html>